From f9a28fc9c3498fbafc009887a20204bdcc7ef0f3 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Mon, 6 Feb 2012 13:13:54 -0600
Subject: UI factory for customizable elements

---
 grade/report/quick_edit/classes/lib.php       |  120 +++---------
 grade/report/quick_edit/classes/uilib.php     |  252 +++++++++++++++++++++++++
 grade/report/quick_edit/screens/grade/lib.php |   46 ++---
 grade/report/quick_edit/screens/user/lib.php  |   32 +--
 4 files changed, 309 insertions(+), 141 deletions(-)
 create mode 100644 grade/report/quick_edit/classes/uilib.php

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index b46998a..ab76819 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -1,13 +1,7 @@
 <?php
 
-abstract class post_processor {
-    abstract class function handle($data);
-}
-
-class quick_edit_grade_processor extends post_processor {
-    function handle($data) {
-    }
-}
+require_once $CFG->dirroot . '/grade/report/quick_edit/classes/uilib.php';
+require_once $CFG->dirroot . '/grade/report/quick_edit/classes/datalib.php';
 
 abstract class quick_edit_screen {
     var $courseid;
@@ -43,27 +37,6 @@ abstract class quick_edit_screen {
         }
     }
 
-    public function format_range($item) {
-        $decimals = $item->get_decimals();
-
-        $min = format_float($item->grademin, $decimals);
-        $max = format_float($item->grademax, $decimals);
-
-        return "$min - $max";
-    }
-
-    public function format_override($grade) {
-        if (!$grade->grade_item->is_overridable_item()) {
-            return get_string('notavailable', 'gradereport_quick_edit');
-        }
-
-        return $this->checkbox_attribute($grade, 'override', $grade->is_overridden());
-    }
-
-    public function format_exclude($grade) {
-        return $this->checkbox_attribute($grade, 'exclude', $grade->is_excluded());
-    }
-
     public function fetch_grade_or_default($item, $user) {
         $grade = grade_grade::fetch(array(
             'itemid' => $item->id, 'userid' => $user->id
@@ -105,88 +78,45 @@ abstract class quick_edit_screen {
             $this->make_toggle($key);
     }
 
-    protected function checkbox_attribute($grade, $post_name, $is_checked) {
-        $name = $post_name . '_' . $grade->itemid . '_' . $grade->userid;
+    public function heading() {
+        return get_string('pluginname', 'gradereport_quick_edit');
+    }
 
-        $attributes = array(
-            'type' => 'checkbox',
-            'name' => $name,
-            'value' => 1
-        );
+    public abstract function init();
 
-        $hidden = array(
-            'type' => 'hidden',
-            'name' => 'old' . $name
-        );
+    public abstract function html();
 
-        if ($is_checked) {
-            $attributes['checked'] = 'CHECKED';
-            $hidden['value'] = 1;
+    public function factory() {
+        if (empty($this->__factory)) {
+            $this->__factory = new quick_edit_grade_ui_factory();
         }
 
-        return (
-            html_writer::empty_tag('input', $attributes) .
-            html_writer::empty_tag('input', $hidden)
-        );
+        return $this->__factory;
     }
 
-    public function format_grade($grade) {
-        $finalgrade = $grade->finalgrade ?
-            format_float($grade->finalgrade, $grade->grade_item->get_decimals()) :
-            '';
-
-        $is_disabled = ($grade->grade_item->is_overridable_item() and !$grade->is_overridden());
-
-        return $this->text_attribute($grade, 'grade', $finalgrade, $is_disabled);
+    public function processor() {
+        return new quick_edit_grade_processor($this->courseid);
     }
+}
 
-    public function format_feedback($grade) {
-        $feedback = $grade->feedback ?
-            format_text($grade->feedback, $grade->feedbackformat) :
-            '';
+abstract class quick_edit_tablelike extends quick_edit_screen {
+    var $items;
 
-        $is_disabled = (
-            $grade->grade_item->is_overridable_item_feedback() and
-            !$grade->is_overridden()
-        );
+    public abstract function headers();
 
-        return $this->text_attribute($grade, 'feedback', $feedback, $is_disabled);
-    }
+    public abstract function format_line($item);
 
-    public function heading() {
-        return get_string('pluginname', 'gradereport_quick_edit');
-    }
+    public function html() {
+        $table = new html_table();
 
-    protected function text_attribute($grade, $post_name, $value, $is_disabled = false) {
-        $name = $post_name . '_' . $grade->itemid . '_' . $grade->userid;
+        $table->head = $this->headers();
 
-        $attributes = array(
-            'type' => 'text',
-            'name' => $name,
-            'value' => $value
-        );
+        $table->data = array();
 
-        if ($is_disabled) {
-            $attributes['disabled'] = 'DISABLED';
+        foreach ($this->items as $item) {
+            $table->data[] = $this->format_line($item);
         }
 
-        $hidden = array(
-            'type' => 'hidden',
-            'name' => 'old' . $name,
-            'value' => $value
-        );
-
-        return (
-            html_writer::empty_tag('input', $attributes) .
-            html_writer::empty_tag('input', $hidden)
-        );
-    }
-
-    public abstract function init();
-
-    public abstract function html();
-
-    public function processor() {
-        return new quick_edit_grade_processor();
+        return html_writer::table($table);
     }
 }
diff --git a/grade/report/quick_edit/classes/uilib.php b/grade/report/quick_edit/classes/uilib.php
new file mode 100644
index 0000000..e36a0dc
--- /dev/null
+++ b/grade/report/quick_edit/classes/uilib.php
@@ -0,0 +1,252 @@
+<?php
+
+abstract class quick_edit_ui_factory {
+    public abstract function create($type);
+
+    protected function wrap($class) {
+        return new quick_edit_factory_class_wrap($class);
+    }
+}
+
+class quick_edit_grade_ui_factory extends quick_edit_ui_factory {
+    public function create($type) {
+        return $this->wrap("quick_edit_{$type}_ui");
+    }
+}
+
+class quick_edit_factory_class_wrap {
+    function __construct($class) {
+        $this->class = $class;
+    }
+
+    function format($what) {
+        return new $this->class($what);
+    }
+}
+
+abstract class quick_edit_ui_element {
+    var $name;
+    var $value;
+
+    function __construct($name, $value) {
+        $this->name = $name;
+        $this->value = $value;
+    }
+
+    abstract function html();
+}
+
+class quick_edit_empty_element extends quick_edit_ui_element {
+    function __construct($msg = null) {
+        if (is_null($msg)) {
+            $this->text = get_string('notavailable', 'gradereport_quick_edit');
+        } else {
+            $this->text = $msg;
+        }
+    }
+
+    function html() {
+        return $this->text;
+    }
+}
+
+class quick_edit_text_attribute extends quick_edit_ui_element {
+    var $is_disabled;
+
+    function __construct($name, $value, $is_disabled = false) {
+        $this->is_disabled = $is_disabled;
+        parent::__construct($name, $value);
+    }
+
+    function html() {
+        $attributes = array(
+            'type' => 'text',
+            'name' => $this->name,
+            'value' => $this->value
+        );
+
+        if ($this->is_disabled) {
+            $attributes['disabled'] = 'DISABLED';
+        }
+
+        $hidden = array(
+            'type' => 'hidden',
+            'name' => 'old' . $this->name,
+            'value' => $this->value
+        );
+
+        return (
+            html_writer::empty_tag('input', $attributes) .
+            html_writer::empty_tag('input', $hidden)
+        );
+    }
+}
+
+class quick_edit_checkbox_attribute extends quick_edit_ui_element {
+    var $is_checked;
+
+    function __construct($name, $is_checked = false) {
+        $this->is_checked = $is_checked;
+        parent::__construct($name, 1);
+    }
+
+    function html() {
+        $attributes = array(
+            'type' => 'checkbox',
+            'name' => $this->name,
+            'value' => 1
+        );
+
+        $hidden = array(
+            'type' => 'hidden',
+            'name' => 'old' . $this->name
+        );
+
+        if ($this->is_checked) {
+            $attributes['checked'] = 'CHECKED';
+            $hidden['value'] = 1;
+        }
+
+        return (
+            html_writer::empty_tag('input', $attributes) .
+            html_writer::empty_tag('input', $hidden)
+        );
+    }
+}
+
+abstract class quick_edit_attribute_format {
+    abstract function determine_format();
+
+    function __toString() {
+        return $this->determine_format()->html();
+    }
+}
+
+abstract class quick_edit_grade_attribute_format extends quick_edit_attribute_format implements unique_name {
+    var $name;
+
+    function __construct($grade) {
+        $this->grade = $grade;
+    }
+
+    function get_name() {
+        return "{$this->name}_{$this->grade->itemid}_{$this->grade->userid}";
+    }
+}
+
+interface unique_name {
+    function get_name();
+}
+
+interface unique_value {
+    function get_value();
+}
+
+interface be_disabled {
+    function is_disabled();
+}
+
+interface be_checked {
+    function is_checked();
+}
+
+class quick_edit_finalgrade_ui extends quick_edit_grade_attribute_format implements unique_value, be_disabled {
+
+    var $name = 'finalgrade';
+
+    function get_value() {
+        return $this->grade->finalgrade ?
+            format_float($this->grade->finalgrade, $this->grade->grade_item->get_decimals()) :
+            '';
+    }
+
+    function is_disabled() {
+        return (
+            $this->grade->grade_item->is_overridable_item() and
+            !$this->grade->is_overridden()
+        );
+    }
+
+    function determine_format() {
+        return new quick_edit_text_attribute(
+            $this->get_name(),
+            $this->get_value(),
+            $this->is_disabled()
+        );
+    }
+}
+
+class quick_edit_feedback_ui extends quick_edit_grade_attribute_format implements unique_value, be_disabled {
+
+    var $name = 'feedback';
+
+    function get_value() {
+        return $this->grade->feedback ?
+            format_text($this->grade->feedback, $this->grade->feedbackformat) :
+            '';
+    }
+
+    function is_disabled() {
+        return (
+            $this->grade->grade_item->is_overridable_item_feedback() and
+            !$this->grade->is_overridden()
+        );
+    }
+
+    function determine_format() {
+        return new quick_edit_text_attribute(
+            $this->get_name(),
+            $this->get_value(),
+            $this->is_disabled()
+        );
+    }
+}
+
+class quick_edit_override_ui extends quick_edit_grade_attribute_format implements be_checked {
+    var $name = 'override';
+
+    function is_checked() {
+        return $this->grade->is_overridden();
+    }
+
+    function determine_format() {
+        if (!$this->grade->grade_item->is_overridable_item()) {
+            return new quick_edit_empty_element();
+        }
+
+        return new quick_edit_checkbox_attribute(
+            $this->get_name(),
+            $this->is_checked()
+        );
+    }
+}
+
+class quick_edit_exclude_ui extends quick_edit_grade_attribute_format implements be_checked {
+    var $name = 'exclude';
+
+    function is_checked() {
+        return $this->grade->is_excluded();
+    }
+
+    function determine_format() {
+        return new quick_edit_checkbox_attribute(
+            $this->get_name(),
+            $this->is_checked()
+        );
+    }
+}
+
+class quick_edit_range_ui extends quick_edit_attribute_format {
+    function __construct($item) {
+        $this->item = $item;
+    }
+
+    function determine_format() {
+        $decimals = $this->item->get_decimals();
+
+        $min = format_float($this->item->grademin, $decimals);
+        $max = format_float($this->item->grademax, $decimals);
+
+        return new quick_edit_empty_element("$min - $max");
+    }
+}
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index 39e3e9b..ee7b4c6 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -1,10 +1,14 @@
 <?php
 
-class quick_edit_grade extends quick_edit_screen {
+class quick_edit_grade extends quick_edit_tablelike {
 
     private $requires_extra;
 
+    private $structure;
+
     public function init() {
+        global $DB;
+
         $params = array(
             'id' => $this->itemid,
             'courseid' => $this->courseid
@@ -14,24 +18,15 @@ class quick_edit_grade extends quick_edit_screen {
 
         $this->item = grade_item::fetch($params);
 
-        $this->users = get_role_users($roleids, $this->context, false, '',
+        $this->items = get_role_users($roleids, $this->context, false, '',
             'u.lastname, u.firstname', null, $this->groupid);
 
         $this->requires_extra = !$this->item->is_manual_item();
-    }
-
-    public function html() {
-        $table = new html_table();
-
-        $table->head = $this->headers();
 
-        $table->data = array();
-
-        foreach ($this->users as $user) {
-            $table->data[] = $this->format_line($user);
-        }
-
-        return html_writer::table($table);
+        $this->structure = new grade_structure();
+        $this->structure->modinfo = get_fast_modinfo(
+            $DB->get_record('course', array('id' => $this->courseid))
+        );
     }
 
     public function headers() {
@@ -46,21 +41,22 @@ class quick_edit_grade extends quick_edit_screen {
         return $this->additional_headers($headers);
     }
 
-    public function format_line($user) {
+    public function format_line($item) {
         global $OUTPUT;
 
-        $grade = $this->fetch_grade_or_default($this->item, $user);
+        $grade = $this->fetch_grade_or_default($this->item, $item);
 
-        $fullname = fullname($user);
+        $fullname = fullname($item);
 
-        $user->imagealt = $fullname;
+        $item->imagealt = $fullname;
 
         $line = array(
-            $OUTPUT->user_picture($user),
-            $this->format_link('user', $user->id, $fullname),
+            $OUTPUT->user_picture($item),
+            $this->format_link('user', $item->id, $fullname),
             $this->item_range(),
-            $this->format_grade($grade),
-            $this->format_feedback($grade)
+            $this->factory()->create('finalgrade')->format($grade) .
+            $this->structure->get_grade_analysis_icon($grade),
+            $this->factory()->create('feedback')->format($grade)
         );
 
         return $this->additional_cells($line, $grade);
@@ -68,7 +64,7 @@ class quick_edit_grade extends quick_edit_screen {
 
     public function additional_cells($line, $grade) {
         if ($this->requires_extra) {
-            $line[] = $this->format_override($grade);
+            $line[] = $this->factory()->create('override')->format($grade);
         }
 
         return $line;
@@ -84,7 +80,7 @@ class quick_edit_grade extends quick_edit_screen {
 
     public function item_range() {
         if (empty($this->range)) {
-            $this->range = $this->format_range($this->item);
+            $this->range = $this->factory()->create('range')->format($this->item);
         }
 
         return $this->range;
diff --git a/grade/report/quick_edit/screens/user/lib.php b/grade/report/quick_edit/screens/user/lib.php
index 3895cdc..da87092 100644
--- a/grade/report/quick_edit/screens/user/lib.php
+++ b/grade/report/quick_edit/screens/user/lib.php
@@ -1,6 +1,6 @@
 <?php
 
-class quick_edit_user extends quick_edit_screen {
+class quick_edit_user extends quick_edit_tablelike {
 
     private $categories = array();
 
@@ -15,23 +15,12 @@ class quick_edit_user extends quick_edit_screen {
 
         $filter_items = grade_report_quick_edit::only_items();
 
-        $this->grade_items = array_filter(grade_item::fetch_all($params), $filter_items);
+        $this->items= array_filter(grade_item::fetch_all($params), $filter_items);
 
         $this->structure = new grade_structure();
-    }
-
-    public function html() {
-        $table = new html_table();
-
-        $table->head = $this->headers();
-
-        $table->data = array();
-
-        foreach ($this->grade_items as $item) {
-            $table->data[] = $this->format_line($item);
-        }
-
-        return html_writer::table($table);
+        $this->structure->modinfo = get_fast_modinfo(
+            $DB->get_record('course', array('id' => $this->courseid))
+        );
     }
 
     public function headers() {
@@ -56,11 +45,12 @@ class quick_edit_user extends quick_edit_screen {
             $this->format_icon($item),
             $this->format_link('grade', $item->id, $item->itemname),
             $this->category($item)->get_name(),
-            $this->format_range($item),
-            $this->format_grade($grade),
-            $this->format_feedback($grade),
-            $this->format_override($grade),
-            $this->format_exclude($grade)
+            $this->factory()->create('range')->format($item),
+            $this->factory()->create('finalgrade')->format($grade) .
+            $this->structure->get_grade_analysis_icon($grade),
+            $this->factory()->create('feedback')->format($grade),
+            $this->factory()->create('override')->format($grade),
+            $this->factory()->create('exclude')->format($grade)
         );
     }
 
-- 
1.7.1


